Index: /palm/trunk/SOURCE/netcdf_interface_mod.f90
===================================================================
--- /palm/trunk/SOURCE/netcdf_interface_mod.f90	(revision 3420)
+++ /palm/trunk/SOURCE/netcdf_interface_mod.f90	(revision 3421)
@@ -2591,7 +3025,124 @@
 
              DEALLOCATE( netcdf_data )
-
-          ENDIF
-
+!
+!--          Write UTM coordinates
+             IF ( init_model%rotation_angle == 0.0_wp )  THEN
+!
+!--             1D in case of no rotation
+                cos_ra = COS( init_model%rotation_angle * pi / 180.0_wp )
+!
+!--             x coordinates
+                ALLOCATE( netcdf_data(0:nx) )
+                DO  k = 0, 2
+!               
+!--                Scalar grid points
+                   IF ( k == 0 )  THEN
+                      shift_x = 0.5
+!               
+!--                u grid points
+                   ELSEIF ( k == 1 )  THEN
+                      shift_x = 0.0
+!               
+!--                v grid points
+                   ELSEIF ( k == 2 )  THEN
+                      shift_x = 0.5
+                   ENDIF
+                
+                   DO  i = 0, nx
+                     netcdf_data(i) = init_model%origin_x            &
+                                    + cos_ra * ( i + shift_x ) * dx
+                   ENDDO
+                
+                   nc_stat = NF90_PUT_VAR( id_set_xy(av), id_var_eutm_xy(av,k),&
+                                           netcdf_data, start = (/ 1 /),   &
+                                           count = (/ nx+1 /) )
+                   CALL netcdf_handle_error( 'netcdf_define_header', 555 )
+
+                ENDDO
+                DEALLOCATE( netcdf_data )
+!
+!--             y coordinates
+                ALLOCATE( netcdf_data(0:ny) )
+                DO  k = 0, 2
+!
+!--                Scalar grid points
+                   IF ( k == 0 )  THEN
+                      shift_y = 0.5
+!
+!--                u grid points
+                   ELSEIF ( k == 1 )  THEN
+                      shift_y = 0.5
+!
+!--                v grid points
+                   ELSEIF ( k == 2 )  THEN
+                      shift_y = 0.0
+                   ENDIF
+
+                   DO  j = 0, ny
+                      netcdf_data(j) = init_model%origin_y            &
+                                     + cos_ra * ( j + shift_y ) * dy
+                   ENDDO
+
+                   nc_stat = NF90_PUT_VAR( id_set_xy(av), id_var_nutm_xy(av,k),&
+                                           netcdf_data, start = (/ 1 /),   &
+                                           count = (/ ny+1 /) )
+                   CALL netcdf_handle_error( 'netcdf_define_header', 556 )
+
+                ENDDO
+                DEALLOCATE( netcdf_data )
+
+             ELSE
+!
+!--             2D in case of rotation
+                ALLOCATE( netcdf_data_2d(0:nx,0:ny) )
+                cos_ra = COS( init_model%rotation_angle * pi / 180.0_wp )
+                sin_ra = SIN( init_model%rotation_angle * pi / 180.0_wp )
+                
+                DO  k = 0, 2
+!               
+!--               Scalar grid points
+                  IF ( k == 0 )  THEN
+                     shift_x = 0.5 ; shift_y = 0.5
+!               
+!--               u grid points
+                  ELSEIF ( k == 1 )  THEN
+                     shift_x = 0.0 ; shift_y = 0.5
+!               
+!--               v grid points
+                  ELSEIF ( k == 2 )  THEN
+                     shift_x = 0.5 ; shift_y = 0.0
+                  ENDIF
+                
+                  DO  j = 0, ny
+                     DO  i = 0, nx
+                        netcdf_data_2d(i,j) = init_model%origin_x            &
+                                            + cos_ra * ( i + shift_x ) * dx  &
+                                            + sin_ra * ( j + shift_y ) * dy
+                     ENDDO
+                  ENDDO
+                
+                  nc_stat = NF90_PUT_VAR( id_set_xy(av), id_var_eutm_xy(av,k),  &
+                                          netcdf_data_2d, start = (/ 1, 1 /),   &
+                                          count = (/ nx+1, ny+1 /) )
+                  CALL netcdf_handle_error( 'netcdf_define_header', 555 )
+                
+                  DO  j = 0, ny
+                     DO  i = 0, nx
+                        netcdf_data_2d(i,j) = init_model%origin_y            &
+                                            - sin_ra * ( i + shift_x ) * dx  &
+                                            + cos_ra * ( j + shift_y ) * dy
+                     ENDDO
+                  ENDDO
+                
+                  nc_stat = NF90_PUT_VAR( id_set_xy(av), id_var_nutm_xy(av,k),  &
+                                          netcdf_data_2d, start = (/ 1, 1 /),   &
+                                          count = (/ nx+1, ny+1 /) )
+                  CALL netcdf_handle_error( 'netcdf_define_header', 556 )
+                
+                ENDDO
+                DEALLOCATE( netcdf_data_2d )
+             ENDIF
+
+          ENDIF
 !
 !--       In case of non-flat topography write height information. Only for 
@@ -2985,4 +3536,57 @@
                                   NF90_DOUBLE, id_var_zw_xz(av), 'meters', '', &
                                   157, 158, 000 )
+!
+!--       Define UTM coordinates
+          IF ( init_model%rotation_angle == 0.0_wp )  THEN
+             CALL netcdf_create_var( id_set_xz(av), &
+                                 (/ id_dim_x_xz(av) /),      &
+                                 'E_UTM', NF90_DOUBLE, id_var_eutm_xz(av,0),  &
+                                 'm', '', 000, 000, 000 )
+             CALL netcdf_create_var( id_set_xz(av), &
+                                 (/ id_dim_y_xz(av) /),      &
+                                 'N_UTM', NF90_DOUBLE, id_var_nutm_xz(av,0),  &
+                                 'm', '', 000, 000, 000 )
+             CALL netcdf_create_var( id_set_xz(av), &
+                                 (/ id_dim_xu_xz(av) /),     &
+                                 'Eu_UTM', NF90_DOUBLE, id_var_eutm_xz(av,1), &
+                                 'm', '', 000, 000, 000 )
+             CALL netcdf_create_var( id_set_xz(av), &
+                                 (/ id_dim_y_xz(av) /),     &
+                                 'Nu_UTM', NF90_DOUBLE, id_var_nutm_xz(av,1), &
+                                 'm', '', 000, 000, 000 )
+             CALL netcdf_create_var( id_set_xz(av), &
+                                 (/ id_dim_x_xz(av) /),     &
+                                 'Ev_UTM', NF90_DOUBLE, id_var_eutm_xz(av,2), &
+                                 'm', '', 000, 000, 000 )
+             CALL netcdf_create_var( id_set_xz(av), &
+                                 (/ id_dim_yv_xz(av) /),     &
+                                 'Nv_UTM', NF90_DOUBLE, id_var_nutm_xz(av,2), &
+                                 'm', '', 000, 000, 000 )
+          ELSE
+             CALL netcdf_create_var( id_set_xz(av), &
+                                 (/ id_dim_x_xz(av), id_dim_y_xz(av) /),      &
+                                 'E_UTM', NF90_DOUBLE, id_var_eutm_xz(av,0),  &
+                                 'm', '', 000, 000, 000 )
+             CALL netcdf_create_var( id_set_xz(av), &
+                                 (/ id_dim_x_xz(av), id_dim_y_xz(av) /),      &
+                                 'N_UTM', NF90_DOUBLE, id_var_nutm_xz(av,0),  &
+                                 'm', '', 000, 000, 000 )
+             CALL netcdf_create_var( id_set_xz(av), &
+                                 (/ id_dim_xu_xz(av), id_dim_y_xz(av) /),     &
+                                 'Eu_UTM', NF90_DOUBLE, id_var_eutm_xz(av,1), &
+                                 'm', '', 000, 000, 000 )
+             CALL netcdf_create_var( id_set_xz(av), &
+                                 (/ id_dim_xu_xz(av), id_dim_y_xz(av) /),     &
+                                 'Nu_UTM', NF90_DOUBLE, id_var_nutm_xz(av,1), &
+                                 'm', '', 000, 000, 000 )
+             CALL netcdf_create_var( id_set_xz(av), &
+                                 (/ id_dim_x_xz(av), id_dim_yv_xz(av) /),     &
+                                 'Ev_UTM', NF90_DOUBLE, id_var_eutm_xz(av,2), &
+                                 'm', '', 000, 000, 000 )
+             CALL netcdf_create_var( id_set_xz(av), &
+                                 (/ id_dim_x_xz(av), id_dim_yv_xz(av) /),     &
+                                 'Nv_UTM', NF90_DOUBLE, id_var_nutm_xz(av,2), &
+                                 'm', '', 000, 000, 000 )
+          ENDIF
 
           IF ( land_surface )  THEN
@@ -3011,8 +3615,9 @@
 !
 !--                Most variables are defined on the zu grid
-                   CASE ( 'e_xz', 'lpt_xz', 'nc_xz', 'nr_xz', 'p_xz', 'pc_xz', &
-                          'pr_xz', 'prr_xz', 'pt_xz', 'q_xz', 'qc_xz',         &
+                   CASE ( 'e_xz', 'nc_xz', 'nr_xz', 'p_xz', 'pc_xz',           &
+                          'pr_xz', 'prr_xz', 'q_xz', 'qc_xz',                  &
                           'ql_xz', 'ql_c_xz', 'ql_v_xz', 'ql_vp_xz', 'qr_xz',  &
-                          'qv_xz', 'rho_ocean_xz', 's_xz', 'sa_xz', 'vpt_xz' )
+                          'qv_xz', 's_xz',                                     &
+                          'theta_xz', 'thetal_xz', 'thetav_xz'                 )
 
                       grid_x = 'x'
@@ -3055,4 +3660,10 @@
                       ENDIF
 
+!
+!--                   Check for ocean quantities
+                      IF ( .NOT. found  .AND.  ocean_mode )  THEN
+                         CALL ocean_define_netcdf_grid( do2d(av,i), found,  &
+                                                        grid_x, grid_y, grid_z )
+                      ENDIF
 !
 !--                   Check for radiation quantities
@@ -3294,6 +3905,135 @@
              ENDIF
 
-
              DEALLOCATE( netcdf_data )
+!
+!--          Write UTM coordinates
+             IF ( init_model%rotation_angle == 0.0_wp )  THEN
+!
+!--             1D in case of no rotation
+                cos_ra = COS( init_model%rotation_angle * pi / 180.0_wp )
+!
+!--             x coordinates
+                ALLOCATE( netcdf_data(0:nx) )
+                DO  k = 0, 2
+!               
+!--                Scalar grid points
+                   IF ( k == 0 )  THEN
+                      shift_x = 0.5
+!               
+!--                u grid points
+                   ELSEIF ( k == 1 )  THEN
+                      shift_x = 0.0
+!               
+!--                v grid points
+                   ELSEIF ( k == 2 )  THEN
+                      shift_x = 0.5
+                   ENDIF
+                
+                   DO  i = 0, nx
+                     netcdf_data(i) = init_model%origin_x            &
+                                    + cos_ra * ( i + shift_x ) * dx
+                   ENDDO
+                
+                   nc_stat = NF90_PUT_VAR( id_set_xz(av), id_var_eutm_xz(av,k),&
+                                           netcdf_data, start = (/ 1 /),   &
+                                           count = (/ nx+1 /) )
+                   CALL netcdf_handle_error( 'netcdf_define_header', 555 )
+
+                ENDDO
+                DEALLOCATE( netcdf_data )
+!
+!--             y coordinates
+                ALLOCATE( netcdf_data(1:ns) )
+                DO  k = 0, 2
+!
+!--                Scalar grid points
+                   IF ( k == 0 )  THEN
+                      shift_y = 0.5
+!
+!--                u grid points
+                   ELSEIF ( k == 1 )  THEN
+                      shift_y = 0.5
+!
+!--                v grid points
+                   ELSEIF ( k == 2 )  THEN
+                      shift_y = 0.0
+                   ENDIF
+
+                   DO  i = 1, ns
+                      IF( section(i,2) == -1 )  THEN
+                         netcdf_data(i) = -1.0_wp  ! section averaged along y
+                      ELSE
+                         netcdf_data(i) = init_model%origin_y &
+                                     + cos_ra * ( section(i,2) + shift_y ) * dy
+                      ENDIF
+                   ENDDO
+
+                   nc_stat = NF90_PUT_VAR( id_set_xz(av), id_var_nutm_xz(av,k),&
+                                           netcdf_data, start = (/ 1 /),   &
+                                           count = (/ ns /) )
+                   CALL netcdf_handle_error( 'netcdf_define_header', 556 )
+
+                ENDDO
+                DEALLOCATE( netcdf_data )
+
+             ELSE
+!
+!--             2D in case of rotation
+                ALLOCATE( netcdf_data_2d(0:nx,1:ns) )
+                cos_ra = COS( init_model%rotation_angle * pi / 180.0_wp )
+                sin_ra = SIN( init_model%rotation_angle * pi / 180.0_wp )
+                
+                DO  k = 0, 2
+!               
+!--                Scalar grid points
+                   IF ( k == 0 )  THEN
+                      shift_x = 0.5 ; shift_y = 0.5
+!                  
+!--                u grid points
+                   ELSEIF ( k == 1 )  THEN
+                      shift_x = 0.0 ; shift_y = 0.5
+!                  
+!--                v grid points
+                   ELSEIF ( k == 2 )  THEN
+                      shift_x = 0.5 ; shift_y = 0.0
+                   ENDIF
+
+                   DO  j = 1, ns
+                      IF( section(j,2) == -1 )  THEN
+                         netcdf_data_2d(:,j) = -1.0_wp  ! section averaged along y
+                      ELSE
+                         DO  i = 0, nx
+                            netcdf_data_2d(i,j) = init_model%origin_x          &
+                                    + cos_ra * ( i + shift_x ) * dx            &
+                                    + sin_ra * ( section(j,2) + shift_y ) * dy
+                         ENDDO
+                      ENDIF
+                   ENDDO
+                   
+                   nc_stat = NF90_PUT_VAR( id_set_xz(av), id_var_eutm_xz(av,k),  &
+                                           netcdf_data_2d, start = (/ 1, 1 /),   &
+                                           count = (/ nx+1, ns /) )
+                   CALL netcdf_handle_error( 'netcdf_define_header', 555 )
+                   
+                   DO  j = 1, ns
+                      IF( section(j,2) == -1 )  THEN
+                         netcdf_data_2d(:,j) = -1.0_wp  ! section averaged along y
+                      ELSE
+                         DO  i = 0, nx
+                            netcdf_data_2d(i,j) = init_model%origin_y          &
+                                    - sin_ra * ( i + shift_x ) * dx            &
+                                    + cos_ra * ( section(j,2) + shift_y ) * dy
+                         ENDDO
+                      ENDIF
+                   ENDDO
+                   
+                   nc_stat = NF90_PUT_VAR( id_set_xz(av), id_var_nutm_xz(av,k),  &
+                                           netcdf_data_2d, start = (/ 1, 1 /),   &
+                                           count = (/ nx+1, ns /) )
+                   CALL netcdf_handle_error( 'netcdf_define_header', 556 )
+                
+                ENDDO
+                DEALLOCATE( netcdf_data_2d )
+             ENDIF
 
           ENDIF
@@ -3654,4 +4394,57 @@
                                   NF90_DOUBLE, id_var_zw_yz(av), 'meters', '', &
                                   196, 197, 000 )
+!
+!--       Define UTM coordinates
+          IF ( init_model%rotation_angle == 0.0_wp )  THEN
+             CALL netcdf_create_var( id_set_yz(av), &
+                                 (/ id_dim_x_yz(av) /),      &
+                                 'E_UTM', NF90_DOUBLE, id_var_eutm_yz(av,0),  &
+                                 'm', '', 000, 000, 000 )
+             CALL netcdf_create_var( id_set_yz(av), &
+                                 (/ id_dim_y_yz(av) /),      &
+                                 'N_UTM', NF90_DOUBLE, id_var_nutm_yz(av,0),  &
+                                 'm', '', 000, 000, 000 )
+             CALL netcdf_create_var( id_set_yz(av), &
+                                 (/ id_dim_xu_yz(av) /),     &
+                                 'Eu_UTM', NF90_DOUBLE, id_var_eutm_yz(av,1), &
+                                 'm', '', 000, 000, 000 )
+             CALL netcdf_create_var( id_set_yz(av), &
+                                 (/ id_dim_y_yz(av) /),     &
+                                 'Nu_UTM', NF90_DOUBLE, id_var_nutm_yz(av,1), &
+                                 'm', '', 000, 000, 000 )
+             CALL netcdf_create_var( id_set_yz(av), &
+                                 (/ id_dim_x_yz(av) /),     &
+                                 'Ev_UTM', NF90_DOUBLE, id_var_eutm_yz(av,2), &
+                                 'm', '', 000, 000, 000 )
+             CALL netcdf_create_var( id_set_yz(av), &
+                                 (/ id_dim_yv_yz(av) /),     &
+                                 'Nv_UTM', NF90_DOUBLE, id_var_nutm_yz(av,2), &
+                                 'm', '', 000, 000, 000 )
+          ELSE
+             CALL netcdf_create_var( id_set_yz(av), &
+                                 (/ id_dim_x_yz(av), id_dim_y_yz(av) /),      &
+                                 'E_UTM', NF90_DOUBLE, id_var_eutm_yz(av,0),  &
+                                 'm', '', 000, 000, 000 )
+             CALL netcdf_create_var( id_set_yz(av), &
+                                 (/ id_dim_x_yz(av), id_dim_y_yz(av) /),      &
+                                 'N_UTM', NF90_DOUBLE, id_var_nutm_yz(av,0),  &
+                                 'm', '', 000, 000, 000 )
+             CALL netcdf_create_var( id_set_yz(av), &
+                                 (/ id_dim_xu_yz(av), id_dim_y_yz(av) /),     &
+                                 'Eu_UTM', NF90_DOUBLE, id_var_eutm_yz(av,1), &
+                                 'm', '', 000, 000, 000 )
+             CALL netcdf_create_var( id_set_yz(av), &
+                                 (/ id_dim_xu_yz(av), id_dim_y_yz(av) /),     &
+                                 'Nu_UTM', NF90_DOUBLE, id_var_nutm_yz(av,1), &
+                                 'm', '', 000, 000, 000 )
+             CALL netcdf_create_var( id_set_yz(av), &
+                                 (/ id_dim_x_yz(av), id_dim_yv_yz(av) /),     &
+                                 'Ev_UTM', NF90_DOUBLE, id_var_eutm_yz(av,2), &
+                                 'm', '', 000, 000, 000 )
+             CALL netcdf_create_var( id_set_yz(av), &
+                                 (/ id_dim_x_yz(av), id_dim_yv_yz(av) /),     &
+                                 'Nv_UTM', NF90_DOUBLE, id_var_nutm_yz(av,2), &
+                                 'm', '', 000, 000, 000 )
+          ENDIF
 
           IF ( land_surface )  THEN
@@ -3680,8 +4473,9 @@
 !
 !--                Most variables are defined on the zu grid
-                   CASE ( 'e_yz', 'lpt_yz', 'nc_yz', 'nr_yz', 'p_yz', 'pc_yz', &
-                          'pr_yz','prr_yz', 'pt_yz', 'q_yz', 'qc_yz', 'ql_yz', &
+                   CASE ( 'e_yz', 'nc_yz', 'nr_yz', 'p_yz', 'pc_yz',           &
+                          'pr_yz','prr_yz', 'q_yz', 'qc_yz', 'ql_yz',          &
                           'ql_c_yz', 'ql_v_yz', 'ql_vp_yz', 'qr_yz', 'qv_yz',  &
-                          'rho_ocean_yz', 's_yz', 'sa_yz', 'vpt_yz' )
+                          's_yz',                                              &
+                          'theta_yz', 'thetal_yz', 'thetav_yz' )
 
                       grid_x = 'x'
@@ -3724,4 +4518,10 @@
                       ENDIF
 
+!
+!--                   Check for ocean quantities
+                      IF ( .NOT. found  .AND.  ocean_mode )  THEN
+                         CALL ocean_define_netcdf_grid( do2d(av,i), found,     &
+                                                       grid_x, grid_y, grid_z )
+                      ENDIF
 !
 !--                   Check for radiation quantities
@@ -3951,4 +4751,134 @@
 
              DEALLOCATE( netcdf_data )
+!
+!--          Write UTM coordinates
+             IF ( init_model%rotation_angle == 0.0_wp )  THEN
+!
+!--             1D in case of no rotation
+                cos_ra = COS( init_model%rotation_angle * pi / 180.0_wp )
+!
+!--             x coordinates
+                ALLOCATE( netcdf_data(1:ns) )
+                DO  k = 0, 2
+!               
+!--                Scalar grid points
+                   IF ( k == 0 )  THEN
+                      shift_x = 0.5
+!               
+!--                u grid points
+                   ELSEIF ( k == 1 )  THEN
+                      shift_x = 0.0
+!               
+!--                v grid points
+                   ELSEIF ( k == 2 )  THEN
+                      shift_x = 0.5
+                   ENDIF
+                
+                   DO  i = 1, ns
+                      IF( section(i,3) == -1 )  THEN
+                         netcdf_data(i) = -1.0_wp  ! section averaged along x
+                      ELSE
+                         netcdf_data(i) = init_model%origin_x &
+                                     + cos_ra * ( section(i,3) + shift_x ) * dx
+                      ENDIF
+                   ENDDO
+                
+                   nc_stat = NF90_PUT_VAR( id_set_yz(av), id_var_eutm_yz(av,k),&
+                                           netcdf_data, start = (/ 1 /),   &
+                                           count = (/ ns /) )
+                   CALL netcdf_handle_error( 'netcdf_define_header', 555 )
+
+                ENDDO
+                DEALLOCATE( netcdf_data )
+!
+!--             y coordinates
+                ALLOCATE( netcdf_data(0:ny) )
+                DO  k = 0, 2
+!
+!--                Scalar grid points
+                   IF ( k == 0 )  THEN
+                      shift_y = 0.5
+!
+!--                u grid points
+                   ELSEIF ( k == 1 )  THEN
+                      shift_y = 0.5
+!
+!--                v grid points
+                   ELSEIF ( k == 2 )  THEN
+                      shift_y = 0.0
+                   ENDIF
+
+                   DO  i = 0, ny
+                     netcdf_data(i) = init_model%origin_y            &
+                                    + cos_ra * ( i + shift_y ) * dy
+                   ENDDO
+
+                   nc_stat = NF90_PUT_VAR( id_set_yz(av), id_var_nutm_yz(av,k),&
+                                           netcdf_data, start = (/ 1 /),   &
+                                           count = (/ ny+1 /) )
+                   CALL netcdf_handle_error( 'netcdf_define_header', 556 )
+
+                ENDDO
+                DEALLOCATE( netcdf_data )
+
+             ELSE
+!
+!--             2D in case of rotation
+                ALLOCATE( netcdf_data_2d(1:ns,0:ny) )
+                cos_ra = COS( init_model%rotation_angle * pi / 180.0_wp )
+                sin_ra = SIN( init_model%rotation_angle * pi / 180.0_wp )
+
+                DO  k = 0, 2
+!               
+!--                Scalar grid points
+                   IF ( k == 0 )  THEN
+                      shift_x = 0.5 ; shift_y = 0.5
+!                  
+!--                u grid points
+                   ELSEIF ( k == 1 )  THEN
+                      shift_x = 0.0 ; shift_y = 0.5
+!                  
+!--                v grid points
+                   ELSEIF ( k == 2 )  THEN
+                      shift_x = 0.5 ; shift_y = 0.0
+                   ENDIF
+
+                   DO  j = 0, ny
+                      DO  i = 1, ns
+                         IF( section(i,3) == -1 )  THEN
+                            netcdf_data_2d(i,:) = -1.0_wp !section averaged along x
+                         ELSE
+                            netcdf_data_2d(i,j) = init_model%origin_x          &
+                                    + cos_ra * ( section(i,3) + shift_x ) * dx &
+                                    + sin_ra * ( j + shift_y ) * dy
+                         ENDIF
+                      ENDDO
+                   ENDDO
+                   
+                   nc_stat = NF90_PUT_VAR( id_set_yz(av), id_var_eutm_yz(av,k),  &
+                                           netcdf_data_2d, start = (/ 1, 1 /),   &
+                                           count = (/ ns, ny+1 /) )
+                   CALL netcdf_handle_error( 'netcdf_define_header', 555 )
+                   
+                   DO  j = 0, ny
+                      DO  i = 1, ns
+                         IF( section(i,3) == -1 )  THEN
+                            netcdf_data_2d(i,:) = -1.0_wp !section averaged along x
+                         ELSE
+                            netcdf_data_2d(i,j) = init_model%origin_y          &
+                                    - sin_ra * ( section(i,3) + shift_x ) * dx &
+                                    + cos_ra * ( j + shift_y ) * dy
+                         ENDIF
+                      ENDDO
+                   ENDDO
+
+                   nc_stat = NF90_PUT_VAR( id_set_yz(av), id_var_nutm_yz(av,k),  &
+                                           netcdf_data_2d, start = (/ 1, 1 /),   &
+                                           count = (/ ns, ny+1 /) )
+                   CALL netcdf_handle_error( 'netcdf_define_header', 556 )
+                
+                ENDDO
+                DEALLOCATE( netcdf_data_2d )
+             ENDIF
 
           ENDIF
@@ -4871,7 +5801,8 @@
 !
 !--             Most variables are defined on the zu levels
-                CASE ( 'e', 'lpt', 'nc', 'nr', 'p', 'pc', 'pr', 'prr', 'pt',   &
+                CASE ( 'e', 'nc', 'nr', 'p', 'pc', 'pr', 'prr',   &
                        'q', 'qc', 'ql', 'ql_c', 'ql_v', 'ql_vp', 'qr', 'qv',   &
-                       'rho_ocean', 's', 'sa', 'u', 'v', 'vpt' )
+                       'rho_sea_water', 's', 'sa', &
+                       'theta', 'thetal', 'thetav', 'u', 'v' )
 
                    grid_z = 'zu'
Index: /palm/trunk/SOURCE/ocean_mod.f90
===================================================================
--- /palm/trunk/SOURCE/ocean_mod.f90	(revision 3420)
+++ /palm/trunk/SOURCE/ocean_mod.f90	(revision 3421)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Renamed output variables
+! 
+! 3381 2018-10-19 13:09:06Z raasch
 ! spin-up cooling for ocean surface implemented, see new parameter
 ! surface_cooling_spinup_time
@@ -674,5 +677,5 @@
     SELECT CASE ( TRIM( var ) )
 
-       CASE ( 'rho_ocean' )
+       CASE ( 'rho_sea_water' )
           unit = 'kg/m3'
 
@@ -723,5 +726,5 @@
           unit = dopr_unit
 
-       CASE ( 'rho_ocean' )
+       CASE ( 'rho_sea_water' )
           dopr_index(var_count) = 64
           dopr_unit             = 'kg/m3'
@@ -797,5 +800,6 @@
     SELECT CASE ( TRIM( var ) )
 
-       CASE ( 'rho_ocean', 'sa' )
+       CASE ( 'rho_sea_water', 'rho_sea_water_xy', 'rho_sea_water_xz', &
+              'rho_sea_water_yz', 'sa', 'sa_xy', 'sa_xz', 'sa_yz' )
           grid_x = 'x'
           grid_y = 'y'
@@ -846,5 +850,5 @@
        SELECT CASE ( TRIM( variable ) )
 
-          CASE ( 'rho_ocean' )
+          CASE ( 'rho_sea_water' )
              IF ( .NOT. ALLOCATED( rho_ocean_av ) )  THEN
                 ALLOCATE( rho_ocean_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
@@ -867,5 +871,5 @@
        SELECT CASE ( TRIM( variable ) )
 
-          CASE ( 'rho_ocean' )
+          CASE ( 'rho_sea_water' )
              IF ( ALLOCATED( rho_ocean_av ) )  THEN
                 DO  i = nxlg, nxrg
@@ -899,5 +903,5 @@
        SELECT CASE ( TRIM( variable ) )
 
-          CASE ( 'rho_ocean' )
+          CASE ( 'rho_sea_water' )
              IF ( ALLOCATED( rho_ocean_av ) ) THEN
                 DO  i = nxlg, nxrg
@@ -980,5 +984,5 @@
     SELECT CASE ( TRIM( variable ) )
 
-       CASE ( 'rho_ocean_xy', 'rho_ocean_xz', 'rho_ocean_yz' )
+       CASE ( 'rho_sea_water_xy', 'rho_sea_water_xz', 'rho_sea_water_yz' )
           IF ( av == 0 )  THEN
              to_be_resorted => rho_ocean
@@ -1073,5 +1077,5 @@
     SELECT CASE ( TRIM( variable ) )
 
-       CASE ( 'rho_ocean' )
+       CASE ( 'rho_sea_water' )
           IF ( av == 0 )  THEN
              to_be_resorted => rho_ocean
Index: /palm/trunk/SOURCE/parin.f90
===================================================================
--- /palm/trunk/SOURCE/parin.f90	(revision 3420)
+++ /palm/trunk/SOURCE/parin.f90	(revision 3421)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Added module for data output at surfaces
+! 
+! 3355 2018-10-16 14:03:34Z knoop
 ! - offline nesting separated from large-scale forcing module
 ! - top boundary condition for pressure in offline nesting changed
@@ -512,4 +515,7 @@
     USE statistics,                                                            &
         ONLY:  hom, hom_sum, pr_palm, region, statistic_regions
+
+    USE surface_output_mod,                                                    &
+        ONLY:  surface_output_parin
 
     USE synthetic_turbulence_generator_mod,                                    &
@@ -874,5 +880,11 @@
 !--       Check for module namelists and read them
           CALL lsm_parin
-          CALL bcm_parin
+!
+!--       Check if bulk cloud model is used and read namelist if required
+          CALL bcm_parin 
+!
+!--       Check if surface output is enabled and read 
+!--       &surface_output_parameters if required          
+          CALL surface_output_parin
           CALL usm_parin
           CALL spectra_parin
Index: /palm/trunk/SOURCE/print_1d.f90
===================================================================
--- /palm/trunk/SOURCE/print_1d.f90	(revision 3420)
+++ /palm/trunk/SOURCE/print_1d.f90	(revision 3421)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Renamed output variables
+! 
+! 3241 2018-09-12 15:02:00Z raasch
 ! unused format statement removed
 ! 
@@ -181,9 +184,9 @@
 111 FORMAT (1X,131('-'))
 112 FORMAT (/)
-120 FORMAT ('   k     zu      u     du     v     dv     pt    dpt    ', &
+120 FORMAT ('   k     zu      u     du     v     dv     theta dtheta ', &
             ' e      Km    Kh     l      zu      k')
 121 FORMAT (1X,I4,1X,F7.1,1X,F6.2,1X,F5.2,1X,F6.2,1X,F5.2,2X,F6.2,1X,F5.2, &
             1X,F7.4,1X,F5.2,1X,F5.2,1X,F6.2,1X,F7.1,2X,I4)
-130 FORMAT ('   k     zw       w''pt''      wpt        w''u''       wu       ',&
+130 FORMAT ('   k     zw       w''theta''   wtheta     w''u''       wu       ',&
             '  w''v''       wv        zw      k')
 131 FORMAT (1X,I4,1X,F7.1,6(1X,E10.3),1X,F7.1,2X,I4)
Index: /palm/trunk/SOURCE/spectra_mod.f90
===================================================================
--- /palm/trunk/SOURCE/spectra_mod.f90	(revision 3420)
+++ /palm/trunk/SOURCE/spectra_mod.f90	(revision 3421)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Renamed output variables
+! 
+! 3248 2018-09-14 09:42:06Z sward
 ! Minor formating changes
 ! 
@@ -622,5 +625,5 @@
           d(nzb+1:nzt,nys:nyn,nxl:nxr) = w(nzb+1:nzt,nys:nyn,nxl:nxr)
        
-       CASE ( 'pt' )
+       CASE ( 'theta' )
           pr = 4
           d(nzb+1:nzt,nys:nyn,nxl:nxr) = pt(nzb+1:nzt,nys:nyn,nxl:nxr)
